Package org.apache.nutch.indexer

# Interface IndexWriter

All Superinterfaces:
  `Configurable`, `Pluggable`

All Known Implementing Classes:
  `CloudSearchIndexWriter`, `CSVIndexWriter`, `DummyIndexWriter`, `ElasticIndexWriter`, `KafkaIndexWriter`, `OpenSearch1xIndexWriter`, `RabbitIndexWriter`, `SolrIndexWriter`

public interface IndexWriter extends Pluggable, Configurable

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `X_POINT_ID`
  The name of the extension point.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `close()`
  `void`
  `commit()`
  `void`
  `delete(String key)`
  `Map<String,Map.Entry<String,Object>>`
  `describe()`
  Returns `Map` with the specific parameters the IndexWriter instance can take.
  `void`
  `open(Configuration conf, String name)`
  Deprecated.
  use `open(IndexWriterParams)`} instead.
  `void`
  `open(IndexWriterParams parameters)`
  Initializes the internal variables from a given index writer configuration.
  `void`
  `update(NutchDocument doc)`
  `void`
  `write(NutchDocument doc)`

  ### Methods inherited from interface org.apache.hadoop.conf.Configurable

  `getConf, setConf`

- ## Field Details

  - ### X_POINT_ID

    static final String X_POINT_ID
    The name of the extension point.

- ## Method Details

  - ### open

    @Deprecated void open(Configuration conf, String name) throws IOException
    Deprecated.
    use `open(IndexWriterParams)`} instead.
    Parameters:
      `conf` - Nutch configuration
      `name` - target name of the `IndexWriter` to be opened
    Throws:
      `IOException` - Some exception thrown by some writer.

  - ### open

    void open(IndexWriterParams parameters) throws IOException
    Initializes the internal variables from a given index writer configuration.
    Parameters:
      `parameters` - Params from the index writer configuration.
    Throws:
      `IOException` - Some exception thrown by writer.

  - ### write

    void write(NutchDocument doc) throws IOException
    Throws:
      `IOException`

  - ### delete

    void delete(String key) throws IOException
    Throws:
      `IOException`

  - ### update

    void update(NutchDocument doc) throws IOException
    Throws:
      `IOException`

  - ### commit

    void commit() throws IOException
    Throws:
      `IOException`

  - ### close

    void close() throws IOException
    Throws:
      `IOException`

  - ### describe

    Map<String,Map.Entry<String,Object>> describe()
    Returns `Map` with the specific parameters the IndexWriter instance can take.
    Returns:
      The values of each row. It must have the form <KEY,<DESCRIPTION,VALUE>>.